package com.josh.tiny;
import java.awt.*;

public class PcKeyboard {
	
	
	static class LocalKey {
		
		int lookup;
		
		String name;
		
		int normal;
		
		int shift;
		
		int control;
		
		int alt;
				
		public LocalKey( int lookup, String name , int normal, int shift , int control , int alt ) {
			
			this.lookup  = lookup;
			this.name    = name;
			this.normal  = normal;
			this.shift   = shift;
			this.control = control;
			this.alt     = alt;
			
		}
		
	}
		
	public static LocalKey keys[] = {
	
		new LocalKey( '\\', "\\", 0x005C , 0x005C , 0x005C , 0x005C ),
		new LocalKey( '[' , "[" , 0x005B , 0x007B , 0x001B , 0x1A5B ),
		new LocalKey( ']' , "]" , 0x005D , 0x007D , 0x001D , 0x1B5D ),
		new LocalKey( '|' , "|" , 0x007C , 0x007C , 0x007C , 0x007C ),
		new LocalKey( '{' , "{" , 0x007B , 0x007B , 0x001B , 0x1A5B ),
		new LocalKey( '}' , "}" , 0x007D , 0x007D , 0x001D , 0x1B5D ),
		new LocalKey( '~' , "~" , 0x007E , 0x007E , 0x007E , 0x007E ),
		new LocalKey( '@' , "@" , 0x0040 , 0x0040 , 0x0040 , 0x0040 ),
	

	
		new LocalKey( Event.F1 , "F1" ,  0x3B00  , 0x5400 , 0x5E00 , 0x6800  ),
		new LocalKey( Event.F2 , "F2" ,  0x3C00  , 0x5500 , 0x5F00 , 0x6900  ),
		new LocalKey( Event.F3 , "F3" ,  0x3D00  , 0x5600 , 0x6000 , 0x6A00  ),
		new LocalKey( Event.F4 , "F4" ,  0x3E00  , 0x5700 , 0x6100 , 0x6B00  ),
		new LocalKey( Event.F5 , "F5" ,  0x3F00  , 0x5800 , 0x6200 , 0x6C00  ),
		new LocalKey( Event.F6 , "F6" ,  0x4000  , 0x5900 , 0x6300 , 0x6D00  ),
		new LocalKey( Event.F7 , "F7" ,  0x4100  , 0x5A00 , 0x6400 , 0x6E00  ),
		new LocalKey( Event.F8 , "F8" ,  0x4200  , 0x5B00 , 0x6500 , 0x6F00  ),
		new LocalKey( Event.F9 , "F9" ,  0x4300  , 0x5C00 , 0x6600 , 0x7000  ),
		new LocalKey( Event.F10, "F10",  0x4400  , 0x5D00 , 0x6700 , 0x7100  ),
		new LocalKey( Event.F11, "F11",  0x8500  , 0x8700 , 0x8900 , 0x8B00  ),
		new LocalKey( Event.F12, "F12",  0x8600  , 0x8800 , 0x8A00 , 0x8C00  ),
	
		new LocalKey( Event.TAB        , "TAB"       , 0x0F09 , 0x0F00 , 0x9400 , 0xA500 ),
		new LocalKey( Event.ESCAPE     , "ESC"       , 0x011B , 0x001B , 0x001B , 0x01F0 ),
		new LocalKey( Event.ENTER      , "ENTER"     , 0x1C0D , 0x000D , 0x000A , 0x1CF0 ),
		new LocalKey( ' '              , "SPACE"     , 0x3920 , 0x3920 , 0x0020 , 0x3920 ),
		new LocalKey( Event.BACK_SPACE , "BAKCSPACE" , 0x0E08 , 0x0008 , 0x007F , 0x0EF0 ),
	
		new LocalKey( Event.UP         , "UP"        , 0x4800 , 0x4800 , 0x8D00 , 0x9800 ),
		new LocalKey( Event.DOWN       , "DOWN"      , 0x5000 , 0x5000 , 0x9100 , 0xA000 ),
		new LocalKey( Event.INSERT     , "INS"       , 0x5200 , 0x5200 , 0x9200 , 0xA200 ),
		new LocalKey( Event.DELETE     , "DEL"       , 0x5300 , 0x5300 , 0x9300 , 0xA300 ),
		new LocalKey( Event.LEFT       , "LEFT"      , 0x4B00 , 0x4B00 , 0x7300 , 0x9B00 ),
		new LocalKey( Event.RIGHT      , "RIGHT"     , 0x4D00 , 0x4D00 , 0x7400 , 0x9D00 ),
		new LocalKey( Event.PGUP       , "PAGE-UP"   , 0x4900 , 0x4900 , 0x8500 , 0x9900 ),
		new LocalKey( Event.PGDN       , "PAGE-DOWN" , 0x5100 , 0x5100 , 0x7600 , 0xA100 ),
		new LocalKey( Event.HOME       , "HOME"      , 0x4700 , 0x4700 , 0x7700 , 0x9700 ),
		new LocalKey( Event.END        , "END"       , 0x4F00 , 0x4F00 , 0x7500 , 0x9F00 ),
	
		new LocalKey( 'a' , "a" , 0x0061 , 0x0041 , 0x0001 , 0x1E00 ),
		new LocalKey( 'b' , "b" , 0x0062 , 0x0042 , 0x0002 , 0x3000 ),
		new LocalKey( 'c' , "c" , 0x0063 , 0x0043 , 0x0003 , 0x2E00 ),
		new LocalKey( 'd' , "d" , 0x0064 , 0x0044 , 0x0004 , 0x2000 ),
		new LocalKey( 'e' , "e" , 0x0065 , 0x0045 , 0x0005 , 0x1200 ),
		new LocalKey( 'f' , "f" , 0x0066 , 0x0046 , 0x0006 , 0x2100 ),
		new LocalKey( 'g' , "g" , 0x0067 , 0x0047 , 0x0007 , 0x2200 ),
		new LocalKey( 'h' , "h" , 0x0068 , 0x0048 , 0x0008 , 0x2200 ),
		new LocalKey( 'i' , "i" , 0x0069 , 0x0049 , 0x0009 , 0x2300 ),
		new LocalKey( 'j' , "j" , 0x006A , 0x004A , 0x000A , 0x1700 ),
		new LocalKey( 'k' , "k" , 0x006B , 0x004B , 0x000B , 0x2400 ),
		new LocalKey( 'l' , "l" , 0x006C , 0x004C , 0x000C , 0x2500 ),
		new LocalKey( 'm' , "m" , 0x006D , 0x004D , 0x000D , 0x3200 ),
		new LocalKey( 'n' , "n" , 0x006E , 0x004E , 0x000E , 0x3100 ),
		new LocalKey( 'o' , "o" , 0x006F , 0x004F , 0x000F , 0x1800 ),
		new LocalKey( 'p' , "p" , 0x0070 , 0x0050 , 0x0010 , 0x1900 ),
		new LocalKey( 'q' , "q" , 0x0071 , 0x0051 , 0x0011 , 0x1000 ),
		new LocalKey( 'r' , "r" , 0x0072 , 0x0052 , 0x0012 , 0x1300 ),
		new LocalKey( 's' , "s" , 0x0073 , 0x0053 , 0x0013 , 0x1F00 ),
		new LocalKey( 't' , "t" , 0x0074 , 0x0054 , 0x0014 , 0x1400 ),
		new LocalKey( 'u' , "u" , 0x0075 , 0x0055 , 0x0015 , 0x1600 ),
		new LocalKey( 'v' , "v" , 0x0076 , 0x0056 , 0x0016 , 0x2F00 ),
		new LocalKey( 'w' , "w" , 0x0077 , 0x0057 , 0x0017 , 0x1100 ),
		new LocalKey( 'x' , "x" , 0x0078 , 0x0058 , 0x0018 , 0x2D00 ),
		new LocalKey( 'y' , "y" , 0x0079 , 0x0059 , 0x0019 , 0x1500 ),
		new LocalKey( 'z' , "z" , 0x007A , 0x005A , 0x001A , 0x2C00 ),
	
		new LocalKey( 'A' , "A" , 0x0041 , 0x0041 , 0x0001 , 0x1E00 ),
		new LocalKey( 'B' , "B" , 0x0042 , 0x0042 , 0x0002 , 0x3000 ),
		new LocalKey( 'C' , "C" , 0x0043 , 0x0043 , 0x0003 , 0x2E00 ),
		new LocalKey( 'D' , "D" , 0x0044 , 0x0044 , 0x0004 , 0x2000 ),
		new LocalKey( 'E' , "E" , 0x0045 , 0x0045 , 0x0005 , 0x1200 ),
		new LocalKey( 'F' , "F" , 0x0046 , 0x0046 , 0x0006 , 0x2100 ),
		new LocalKey( 'G' , "G" , 0x0047 , 0x0047 , 0x0007 , 0x2200 ),
		new LocalKey( 'H' , "H" , 0x0048 , 0x0048 , 0x0008 , 0x2200 ),
		new LocalKey( 'I' , "I" , 0x0049 , 0x0049 , 0x0009 , 0x2300 ),
		new LocalKey( 'J' , "J" , 0x004A , 0x004A , 0x000A , 0x1700 ),
		new LocalKey( 'K' , "K" , 0x004B , 0x004B , 0x000B , 0x2400 ),
		new LocalKey( 'L' , "L" , 0x004C , 0x004C , 0x000C , 0x2500 ),
		new LocalKey( 'M' , "M" , 0x004D , 0x004D , 0x000D , 0x3200 ),
		new LocalKey( 'N' , "N" , 0x004E , 0x004E , 0x000E , 0x3100 ),
		new LocalKey( 'O' , "O" , 0x004F , 0x004F , 0x000F , 0x1800 ),
		new LocalKey( 'P' , "P" , 0x0050 , 0x0050 , 0x0010 , 0x1900 ),
		new LocalKey( 'Q' , "Q" , 0x0051 , 0x0051 , 0x0011 , 0x1000 ),
		new LocalKey( 'R' , "R" , 0x0052 , 0x0052 , 0x0012 , 0x1300 ),
		new LocalKey( 'S' , "S" , 0x0053 , 0x0053 , 0x0013 , 0x1F00 ),
		new LocalKey( 'T' , "T" , 0x0054 , 0x0054 , 0x0014 , 0x1400 ),
		new LocalKey( 'U' , "U" , 0x0055 , 0x0055 , 0x0015 , 0x1600 ),
		new LocalKey( 'V' , "V" , 0x0056 , 0x0056 , 0x0016 , 0x2F00 ),
		new LocalKey( 'W' , "W" , 0x0057 , 0x0057 , 0x0017 , 0x1100 ),
		new LocalKey( 'X' , "X" , 0x0058 , 0x0058 , 0x0018 , 0x2D00 ),
		new LocalKey( 'Y' , "Y" , 0x0059 , 0x0059 , 0x0019 , 0x1500 ),
		new LocalKey( 'Z' , "Z" , 0x005A , 0x005A , 0x001A , 0x2C00 ),
	
		new LocalKey( '1' , "1" , 0x0031 , 0x0021 , 0x0011 , 0x7800 ),
		new LocalKey( '2' , "2" , 0x0032 , 0x0040 , 0x0000 , 0x7900 ),
		new LocalKey( '3' , "3" , 0x0033 , 0x0023 , 0x0013 , 0x7A00 ),
		new LocalKey( '4' , "4" , 0x0034 , 0x0024 , 0x0014 , 0x7B00 ),
		new LocalKey( '5' , "5" , 0x0035 , 0x0025 , 0x0015 , 0x7C00 ),
		new LocalKey( '6' , "6" , 0x0036 , 0x005E , 0x001E , 0x7D00 ),
		new LocalKey( '7' , "7" , 0x0037 , 0x0026 , 0x0017 , 0x7E00 ),
		new LocalKey( '8' , "8" , 0x0038 , 0x002A , 0x0018 , 0x7F00 ),
		new LocalKey( '9' , "9" , 0x0039 , 0x0028 , 0x0019 , 0x8000 ),
		new LocalKey( '0' , "0" , 0x0030 , 0x0029 , 0x0010 , 0x8100 ),
		new LocalKey( '-' , "-" , 0x002D , 0x005F , 0x001F , 0x8200 ),
		new LocalKey( '=' , "=" , 0x003D , 0x003D , 0x001D , 0x8300 ),
		new LocalKey( '`' , "`" , 0x0060 , 0x0060 , 0x0000 , 0x2960 ),
		new LocalKey( ';' , ";" , 0x003B , 0x003B , 0x001B , 0x273B ),
		new LocalKey( '\'', "\'", 0x0027 , 0x0022 , 0x0007 , 0x2827 ),
		new LocalKey( ',' , "," , 0x002C , 0x003C , 0x000C , 0x332C ),
		new LocalKey( '.' , "." , 0x002E , 0x003E , 0x000E , 0x342E ),
		new LocalKey( '/' , "/" , 0x002F , 0x002F , 0x000F , 0x352E ),
	
		new LocalKey( '!' , "!" , 0x0021 , 0x0021 , 0x0021 , 0x7800 ),
		new LocalKey( '#' , "#" , 0x0023 , 0x0023 , 0x0023 , 0x7A00 ),
		new LocalKey( '$' , "$" , 0x0024 , 0x0024 , 0x0024 , 0x7B00 ),
		new LocalKey( '%' , "%" , 0x0025 , 0x0025 , 0x0025 , 0x7C00 ),
		new LocalKey( '^' , "^" , 0x005E , 0x005E , 0x001E , 0x7D00 ),
		new LocalKey( '&' , "&" , 0x0026 , 0x0026 , 0x0026 , 0x7E00 ),
		new LocalKey( '*' , "*" , 0x002A , 0x002A , 0x002A , 0x7F00 ),
		new LocalKey( '(' , "(" , 0x0028 , 0x0028 , 0x0028 , 0x8000 ),
		new LocalKey( ')' , ")" , 0x0029 , 0x0029 , 0x0029 , 0x8100 ),
		new LocalKey( '_' , "_" , 0x005F , 0x005F , 0x001F , 0x8200 ),
		new LocalKey( '+' , "+" , 0x002B , 0x002B , 0x002B , 0x8300 ),
		new LocalKey( ':' , ":" , 0x003A , 0x003A , 0x003A , 0x273B ),
		new LocalKey( '<' , "<" , 0x003C , 0x003C , 0x003C , 0x332C ),
		new LocalKey( '>' , ">" , 0x003E , 0x003E , 0x003E , 0x342E ),
		new LocalKey( '?' , "?" , 0x003F , 0x003F , 0x00FF , 0x352E ),
		new LocalKey( '\"' , "\"" , 0x0022 , 0x0022 , 0x0022 , 0x28F0 ),
		new LocalKey( '\'' , "\'" , 0x0027 , 0x0027 , 0x0027 , 0x28F0 ),
	
		new LocalKey( 0x00, "Ctrl-@" , 0x0000 , 0x0000 , 0x0000 , 0x0000 ),
		new LocalKey( 0x01, "Ctrl-A" , 0x0001 , 0x0001 , 0x0001 , 0x1E00 ),
		new LocalKey( 0x02, "Ctrl-B" , 0x0002 , 0x0002 , 0x0002 , 0x3000 ),
		new LocalKey( 0x03, "Ctrl-C" , 0x0003 , 0x0003 , 0x0003 , 0x2E00 ),
		new LocalKey( 0x04, "Ctrl-D" , 0x0004 , 0x0004 , 0x0004 , 0x2000 ),
		new LocalKey( 0x05, "Ctrl-E" , 0x0005 , 0x0005 , 0x0005 , 0x1200 ),
		new LocalKey( 0x06, "Ctrl-F" , 0x0006 , 0x0006 , 0x0006 , 0x2100 ),
		new LocalKey( 0x07, "Ctrl-G" , 0x0007 , 0x0007 , 0x0007 , 0x2200 ),
		new LocalKey( 0x08, "Ctrl-H" , 0x0008 , 0x0008 , 0x0008 , 0x2200 ),
		new LocalKey( 0x09, "Ctrl-I" , 0x0009 , 0x0009 , 0x0009 , 0x2300 ),
		new LocalKey( 0x0A, "Ctrl-J" , 0x000A , 0x000A , 0x000A , 0x1700 ),
		new LocalKey( 0x0B, "Ctrl-K" , 0x000B , 0x000B , 0x000B , 0x2400 ),
		new LocalKey( 0x0C, "Ctrl-L" , 0x000C , 0x000C , 0x000C , 0x2500 ),
		new LocalKey( 0x0D, "Ctrl-M" , 0x000D , 0x000D , 0x000D , 0x3200 ),
		new LocalKey( 0x0E, "Ctrl-N" , 0x000E , 0x000E , 0x000E , 0x3100 ),
		new LocalKey( 0x0F, "Ctrl-O" , 0x000F , 0x000F , 0x000F , 0x1800 ),
		new LocalKey( 0x10, "Ctrl-P" , 0x0010 , 0x0010 , 0x0010 , 0x1900 ),
		new LocalKey( 0x11, "Ctrl-Q" , 0x0011 , 0x0011 , 0x0011 , 0x1000 ),
		new LocalKey( 0x12, "Ctrl-R" , 0x0012 , 0x0012 , 0x0012 , 0x1300 ),
		new LocalKey( 0x13, "Ctrl-S" , 0x0013 , 0x0013 , 0x0013 , 0x1F00 ),
		new LocalKey( 0x14, "Ctrl-T" , 0x0014 , 0x0014 , 0x0014 , 0x1400 ),
		new LocalKey( 0x15, "Ctrl-U" , 0x0015 , 0x0015 , 0x0015 , 0x1600 ),
		new LocalKey( 0x16, "Ctrl-V" , 0x0016 , 0x0016 , 0x0016 , 0x2F00 ),
		new LocalKey( 0x17, "Ctrl-W" , 0x0017 , 0x0017 , 0x0017 , 0x1100 ),
		new LocalKey( 0x18, "Ctrl-X" , 0x0018 , 0x0018 , 0x0018 , 0x2D00 ),
		new LocalKey( 0x19, "Ctrl-Y" , 0x0019 , 0x0019 , 0x0019 , 0x1500 ),
		new LocalKey( 0x1A, "Ctrl-Z" , 0x001A , 0x001A , 0x001A , 0x2C00 ),
		new LocalKey( 0x1B, "Ctrl-[" , 0x001B , 0x001B , 0x001B , 0x001B ),
		new LocalKey( 0x1C, "Ctrl-\\", 0x011C , 0x001C , 0x001C , 0x001C ),
		new LocalKey( 0x1D, "Ctrl-]" , 0x001D , 0x001D , 0x001D , 0x001D ),
		new LocalKey( 0x1E, "Ctrl-^" , 0x001E , 0x001E , 0x001E , 0x001E ),
		new LocalKey( 0x1F, "Ctrl-_" , 0x001F , 0x001F , 0x001F , 0x001F ),
	
	
		
		new LocalKey( 0x84, "" , 0x0084 , 0x008E , 0x0001 , 0x1E00 ),
		new LocalKey( 0x94, "" , 0x0094 , 0x0099 , 0x000F , 0x1800 ),
		new LocalKey( 0x81, "" , 0x0081 , 0x009A , 0x0015 , 0x1600 ),
		new LocalKey( 0xE1, "" , 0x00E1 , 0x00E1 , 0x0013 , 0x1F00 ),

		new LocalKey( 0xA0, "" , 0x00A0 , 0x00A0 , 0x0001 , 0x1E00 ),
		new LocalKey( 0x85, "" , 0x0085 , 0x0085 , 0x0001 , 0x1E00 ),
		new LocalKey( 0x83, "" , 0x0083 , 0x0083 , 0x0001 , 0x1E00 ),
		new LocalKey( 0x86, "" , 0x0086 , 0x008F , 0x0001 , 0x1E00 ),
		new LocalKey( 0x91, "" , 0x0091 , 0x0092 , 0x0001 , 0x1E00 ),
	
		new LocalKey( 0x87, "" , 0x0087 , 0x0080 , 0x0003 , 0x2E00 ),
	
		new LocalKey( 0x82, "" , 0x0082 , 0x0090 , 0x0005 , 0x1200 ),
		new LocalKey( 0x8A, "" , 0x008A , 0x008A , 0x0005 , 0x1200 ),
		new LocalKey( 0x88, "" , 0x0088 , 0x0088 , 0x0005 , 0x1200 ),
		new LocalKey( 0x89, "" , 0x0089 , 0x0089 , 0x0005 , 0x1200 ),
	
		new LocalKey( 0xA1, "" , 0x00A1 , 0x00A1 , 0x0009 , 0x2300 ),
		new LocalKey( 0x8D, "" , 0x008D , 0x008D , 0x0009 , 0x2300 ),
		new LocalKey( 0x8C, "" , 0x008C , 0x008C , 0x0009 , 0x2300 ),
		new LocalKey( 0x8B, "" , 0x008B , 0x008B , 0x0009 , 0x2300 ),
	
		new LocalKey( 0xA4, "" , 0x00A4 , 0x00A5 , 0x000E , 0x3100 ),
	
		new LocalKey( 0xA2, "" , 0x00A2 , 0x00A2 , 0x000F , 0x1800 ),
		new LocalKey( 0x95, "" , 0x0095 , 0x0095 , 0x000F , 0x1800 ),
		new LocalKey( 0x93, "" , 0x0093 , 0x0093 , 0x000F , 0x1800 ),
	
		new LocalKey( 0xA3, "" , 0x00A3 , 0x00A3 , 0x0015 , 0x1600 ),
		new LocalKey( 0x97, "" , 0x0097 , 0x0097 , 0x0015 , 0x1600 ),
		new LocalKey( 0x96, "" , 0x0096 , 0x0096 , 0x0015 , 0x1600 ),
	
		new LocalKey( 0x98, "" , 0x0098 , 0x0098 , 0x0019 , 0x1500 ),
		
		
		new LocalKey( 0xE0, "ALPHA"   , 0x00E0 , 0x00E0 , 0x0001 , 0x1E00 ),
		new LocalKey( 0xE1, "BETA"    , 0x00E1 , 0x00E1 , 0x0002 , 0x3000 ),
		new LocalKey( 0xE2, "GAMMA"   , 0x00E7 , 0x00E2 , 0x0007 , 0x2200 ),
		new LocalKey( 0xEB, "DELTA"   , 0x00EB , 0x00EB , 0x0004 , 0x2000 ),
		new LocalKey( 0xEE, "EPSILON" , 0x00EE , 0x00EE , 0x0005 , 0x1200 ),
		new LocalKey( 0xE9, "THETA"   , 0x00E9 , 0x00E9 , 0x0016 , 0x2F00 ),
		new LocalKey( 0xE6, "MI"      , 0x00E6 , 0x00E6 , 0x000D , 0x3200 ),
		new LocalKey( 0xE3, "PI"      , 0x00E3 , 0x00E3 , 0x0010 , 0x1900 ),
		new LocalKey( 0xE5, "SIGMA"   , 0x00E5 , 0x00E4 , 0x0013 , 0x1F00 ),
		new LocalKey( 0xE8, "PHI"     , 0x00ED , 0x00E8 , 0x0006 , 0x2100 ),
		new LocalKey( 0xEA, "OMEGA"   , 0x00EA , 0x00EA , 0x0017 , 0x1100 ),
	
		new LocalKey( 0xFB, "SQUARE ROOT"      , 0x00FB , 0x00FB , 0x00FB , 0x00FB ),
		new LocalKey( 0xFD, "SQUARE"           , 0x00FD , 0x00FD , 0x00FD , 0x00FD ),
		new LocalKey( 0xF3, "LESS OR EQUAL"    , 0x00F3 , 0x00F3 , 0x00F3 , 0x00F3 ),
		new LocalKey( 0xF2, "GREATER OR EQUAL" , 0x00F2 , 0x00F2 , 0x00F2 , 0x00F2 ),
		new LocalKey( 0xF1, "PLUS-MINUS"       , 0x00F1 , 0x00F1 , 0x00F1 , 0x00F1 ),
		new LocalKey( 0xF7, "NEARLY EQUAL"     , 0x00F7 , 0x00F7 , 0x00F7 , 0x00F7 ),
		
		
	};
	
	
	static final char QUOTE = '\"';
	
	
	// This convience method just prints out the keys in the format used for a translation table file
	
	public static void main( String args[]) {
		
		for( LocalKey k : keys ) {
			
			System.out.printf( "%-20s %6d %6d %6d\r\n" , QUOTE+ k.name +QUOTE , 0 , k.lookup , k.normal );
			
			
			
//			""                     0   223    225
		
			
		}
	}
	


}
